src/base/cs_file.c File Reference

| programmer's documentation

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- File List
- Globals

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Macros | Functions | Variables
cs_file.c File Reference
`#include "cs_defs.h"`
`#include <assert.h>`
`#include <errno.h>`
`#include <limits.h>`
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include <sys/stat.h>`
`#include <sys/types.h>`
`#include <unistd.h>`
`#include <dirent.h>`
`#include "bft_mem.h"`
`#include "bft_error.h"`
`#include "bft_printf.h"`
`#include "cs_file.h"`
Include dependency graph for cs_file.c:

## Macros
#define | CS_FILE_MPI_TAG (int)('C'+'S'+'_'+'F'+'I'+'L'+'E')

## Functions
cs_file_t * | cs_file_open (const char *name, cs_file_mode_t mode, cs_file_access_t method, MPI_Info hints, MPI_Comm block_comm, MPI_Comm comm)
| Create a file descriptor and open the associated file. More...
cs_file_t * | cs_file_open_default (const char *name, cs_file_mode_t mode)
| Create a file descriptor and open the associated file, using the default file communicator and access method. More...
cs_file_t * | cs_file_free (cs_file_t *f)
| Destroy a file descriptor and close the associated file. More...
const char * | cs_file_get_name (const cs_file_t *f)
| Return a file's name. More...
void | cs_file_set_big_endian (cs_file_t *f)
| Ensure that data is read or written in big-endian (network standard) format. More...
int | cs_file_get_swap_endian (const cs_file_t *f)
| Return a file's byte-swapping behavior. More...
void | cs_file_set_swap_endian (cs_file_t *f, int swap)
| Set a file's byte-swapping behavior. More...
size_t | cs_file_read_global (cs_file_t *f, void *buf, size_t size, size_t ni)
| Read global data from a file, distributing it to all processes associated with that file. More...
size_t | cs_file_write_global (cs_file_t *f, const void *buf, size_t size, size_t ni)
| Write global data to a file. More...
size_t | cs_file_read_block (cs_file_t *f, void *buf, size_t size, size_t stride, cs_gnum_t global_num_start, cs_gnum_t global_num_end)
| Read data to a buffer, distributing a contiguous part of it to each process associated with a file. More...
size_t | cs_file_write_block (cs_file_t *f, const void *buf, size_t size, size_t stride, cs_gnum_t global_num_start, cs_gnum_t global_num_end)
| Write data to a file, each associated process providing a contiguous part of this data. More...
size_t | cs_file_write_block_buffer (cs_file_t *f, void *buf, size_t size, size_t stride, cs_gnum_t global_num_start, cs_gnum_t global_num_end)
| Write data to a file, each associated process providing a contiguous part of this data. More...
int | cs_file_seek (cs_file_t *f, cs_file_off_t offset, cs_file_seek_t whence)
| Update the file pointer according to whence. More...
cs_file_off_t | cs_file_tell (cs_file_t *f)
| Return the position of the file pointer. More...
void | cs_file_dump (const cs_file_t *f)
| Dump the metadata of a file structure in human readable form. More...
void | cs_file_get_default_access (cs_file_mode_t mode, cs_file_access_t *method, MPI_Info *hints)
| Get the default options for file access. More...
void | cs_file_set_default_access (cs_file_mode_t mode, cs_file_access_t method, MPI_Info hints)
| Set the default options for file access. More...
void | cs_file_get_default_comm (int *block_rank_step, int *block_min_size, MPI_Comm *block_comm, MPI_Comm *comm)
| Get default MPI communicator values for file access. More...
void | cs_file_set_default_comm (int block_rank_step, int block_min_size, MPI_Comm comm)
| Set default MPI communicator values for file access. More...
cs_file_mpi_positionning_t | cs_file_get_mpi_io_positionning (void)
| Get the positionning method for MPI-IO. More...
void | cs_file_set_mpi_io_positionning (cs_file_mpi_positionning_t positionning)
| Set the positionning method for MPI-IO. More...
void | cs_file_defaults_info (void)
| Print information on default options for file access. More...
cs_file_serializer_t * | cs_file_serializer_create (size_t size, size_t stride, cs_gnum_t global_num_start, cs_gnum_t global_num_end, size_t buf_block_size, void *buf, MPI_Comm comm)
| Create a cs_file_serializer_t structure. More...
void | cs_file_serializer_destroy (cs_file_serializer_t **s)
| Destroy a cs_file_serializer_t structure. More...
void * | cs_file_serializer_advance (cs_file_serializer_t *s, cs_gnum_t cur_range[2])
| Advance a cs_file_serializer_t structure. More...
int | cs_file_mkdir_default (const char *path)
| Create a new directory using default permissions. More...
int | cs_file_isreg (const char *path)
| Check if a file exists and is a regular file. More...
int | cs_file_isdir (const char *path)
| Check if a directory exists. More...
char ** | cs_file_listdir (const char *path)
| List files inside a directory. More...
cs_file_off_t | cs_file_size (const char *path)
| Return the size of a file. More...

## Variables
const char * | cs_file_access_name []
const char * | cs_file_mpi_positionning_name []

## Detailed Description

File and directory operations, with parallel IO.

## Macro Definition Documentation

#define CS_FILE_MPI_TAG (int)('C'+'S'+'_'+'F'+'I'+'L'+'E')

## Function Documentation

void cs_file_defaults_info | ( | void |  | ) |

Print information on default options for file access.

void cs_file_dump | ( | const cs_file_t * | f | ) |

Dump the metadata of a file structure in human readable form.

Parameters

  [in] | f | cs_file_t descriptor

cs_file_t* cs_file_free | ( | cs_file_t * | f | ) |

Destroy a file descriptor and close the associated file.

Parameters

  [in,out] | f | file descriptor to destroy

void cs_file_get_default_access | ( | cs_file_mode_t | mode,
|  | cs_file_access_t * | method,
|  | MPI_Info * | hints
| ) |  |

Get the default options for file access.

Parameters

  [in] | mode | file mode for which the default is queried (write and append use the same method, and are interchangeable here)
  [out] | method | default file access method, or NULL
  [out] | hints | MPI-IO hints, or NULL

void cs_file_get_default_comm | ( | int * | block_rank_step,
|  | int * | block_min_size,
|  | MPI_Comm * | block_comm,
|  | MPI_Comm * | comm
| ) |  |

Get default MPI communicator values for file access.

A block rank stepping value may be used, allowing the use of a reduced communicator for distributed block reads and writes. If this value is greater than 1, ranks not a multiple of this step must be guaranteed to be empty for block reads and writes with files opened using this default.

A minimum block size target may also be used, so as to limit the number of active blocks to a value proportional to the data size (limiting latency issues for small data sets, while not requiring too much local memory).

Parameters

  [out] | block_rank_step | MPI rank stepping between non-empty distributed blocks, or NULL
  [out] | block_min_size | minimum block size target for non-empty distributed blocks, or NULL
  [out] | block_comm | Handle to MPI communicator used for distributed file block access, or NULL
  [out] | comm | Handle to main MPI communicator, or NULL

cs_file_mpi_positionning_t cs_file_get_mpi_io_positionning | ( | void |  | ) |

Get the positionning method for MPI-IO.

For details, see cs_file_set_mpi_io_positionning.

Returns
  positionning method for MPI-IO

const char* cs_file_get_name | ( | const cs_file_t * | f | ) |

Return a file's name.

Parameters

  [in] | f | cs_file_t descriptor

Returns
  pointer to the file's name.

int cs_file_get_swap_endian | ( | const cs_file_t * | f | ) |

Return a file's byte-swapping behavior.

Parameters

  [in] | f | cs_file_t descriptor

Returns
  0 if file's endianness is the same as the system's, 1 otherwise.

int cs_file_isdir | ( | const char * | path | ) |

Check if a directory exists.

Parameters

  [in] | path | directory path.

Returns
  1 if directory exists, 0 otherwise.

int cs_file_isreg | ( | const char * | path | ) |

Check if a file exists and is a regular file.

Parameters

  [in] | path | file path.

Returns
  1 if file exists and is a regular file, 0 otherwise.

char** cs_file_listdir | ( | const char * | path | ) |

List files inside a directory.

The array returned must be freed by the caller using BFT_FREE, as well as the individual entries in the array.

Parameters

  [in] | path | name of directory.

Returns
  an array of file names in a directory. The last entry is set to NULL. If no means to list the directory or an error occured, the return value is simply NULL.

int cs_file_mkdir_default | ( | const char * | path | ) |

Create a new directory using default permissions.

This function is similar to the POSIX function mkdir(), except that it has no "mode" argument: by default, on a POSIX type system, permissions include read, write, and execute access for the user, group and others, modified by the users umask value (so with a typical configuration, the user will have read, write, and execute pemission, the group and others will only have read and execute permission, but this behavior may be modified).

Also, contrary to the usual mkdir(), if the directory already exists (and is truly a directory), this is considered a success and not a failure, and 0 is returned: the aim of this function is to make a directory available, so if it already exists, this is considered acceptable.

Parameters

  [in] | path | name of new directory.

Returns
  0 on success, -1 if an error occured (in which case errno contains the appropriate error code). If the underlying system has no mkdir() function or it was not detected upon BFT configuration, 1 is returned.

cs_file_t* cs_file_open | ( | const char * | name,
|  | cs_file_mode_t | mode,
|  | cs_file_access_t | method,
|  | MPI_Info | hints,
|  | MPI_Comm | block_comm,
|  | MPI_Comm | comm
| ) |  |

Create a file descriptor and open the associated file.

By default, data is written or read as native data. This behavior may be modified by cs_file_set_swap_endian().

Parameters

  [in] | name | file name
  [in] | mode | file acces mode: read, write, or append
  [in] | method | file access method
  [in] | hints | associated hints for MPI-IO, or MPI_INFO_NULL
  [in] | block_comm | handle to MPI communicator used for distributed file block access (may be a subset of comm if some ranks do not directly access distributed data blocks)
  [in] | comm | handle to main MPI communicator

Returns
  pointer to cs_file_t file descriptor (NULL in case of failure); currently, errors are fatal.

cs_file_t* cs_file_open_default | ( | const char * | name,
|  | cs_file_mode_t | mode
| ) |  |

Create a file descriptor and open the associated file, using the default file communicator and access method.

By default, data is written or read as native data. This behavior may be modified by cs_file_set_swap_endian().

Parameters

  [in] | name | file name
  [in] | mode | file acces mode: read, write, or append

Returns
  pointer to cs_file_t file descriptor (NULL in case of failure); currently, errors are fatal.

size_t cs_file_read_block | ( | cs_file_t * | f,
|  | void * | buf,
|  | size_t | size,
|  | size_t | stride,
|  | cs_gnum_t | global_num_start,
|  | cs_gnum_t | global_num_end
| ) |  |

Read data to a buffer, distributing a contiguous part of it to each process associated with a file.

Each process should receive a (possibly empty) block of the data, and we should have: global_num_start at rank 0 = 1 global_num_start at rank i+1 = global_num_end at rank i. Otherwise, behavior (especially positioning for future reads) is undefined.

Parameters

  [in] | f | cs_file_t descriptor
  [out] | buf | pointer to location receiving data
  [in] | size | size of each item of data in bytes
  [in] | stride | number of (interlaced) values per block item
  [in] | global_num_start | global number of first block item (1 to n numbering)
  [in] | global_num_end | global number of past-the end block item (1 to n numbering)

Returns
  the (local) number of items (not bytes) sucessfully read; currently, errors are fatal.

size_t cs_file_read_global | ( | cs_file_t * | f,
|  | void * | buf,
|  | size_t | size,
|  | size_t | ni
| ) |  |

Read global data from a file, distributing it to all processes associated with that file.

Parameters

  [in] | f | cs_file_t descriptor
  [out] | buf | pointer to location receiving data
  [in] | size | size of each item of data in bytes
  [in] | ni | number of items to read

Returns
  the number of items (not bytes) sucessfully read; currently, errors are fatal.

int cs_file_seek | ( | cs_file_t * | f,
|  | cs_file_off_t | offset,
|  | cs_file_seek_t | whence
| ) |  |

Update the file pointer according to whence.

Parameters

  [in,out] | f | cs_file_t descriptor
  [in] | offset | add to position specified to whence to obtain new position, measured in characters from the beginning of the file
  [in] | whence | beginning if CS_FILE_SEEK_SET, current if CS_FILE_SEEK_CUR, or end-of-file if CS_FILE_SEEK_END

Returns
  0 upon success, nonzero otherwise; currently, errors are fatal.

void* cs_file_serializer_advance | ( | cs_file_serializer_t * | s,
|  | cs_gnum_t | cur_range[2]
| ) |  |

Advance a cs_file_serializer_t structure.

Data from the buffer of the next communicating rank is copied to rank 0 (this is a no-op the first time this function is called, as rank 0 already has its data).

On rank 0, the return value may point to the buffer defined when initializing the serializer, or to an aditional buffer if the former is too small to receive data from all ranks.

Note also that for ranks > 0, this function always returns NULL, as only one call is needed for those ranks.

Parameters

  [in] | s | pointer to serializer structure
  [out] | cur_range | optional start and past-the end global numbers for the current block (size: 2), or NULL; only on rank 0

Returns
  a pointer to the buffer containing new data (first call counts as new), or NULL if we are finished; always NULL on ranks > 0.

cs_file_serializer_t* cs_file_serializer_create | ( | size_t | size,
|  | size_t | stride,
|  | cs_gnum_t | global_num_start,
|  | cs_gnum_t | global_num_end,
|  | size_t | buf_block_size,
|  | void * | buf,
|  | MPI_Comm | comm
| ) |  |

Create a cs_file_serializer_t structure.

The buf_block_size argument is optional, and may be used when the buffer on rank 0 is larger than (global_num_end - global_num_start)*size*stride bytes. If zero, a block size of (global_num_end - global_num_start) on rank 0 is assumed; a buffer may not be smaller than this, as it must initially contain all data on rank 0's block.

Parameters

  [in] | size | size of each item of data in bytes
  [in] | stride | number of (interlaced) values per block item
  [in] | global_num_start | global number of first block item (1 to n numbering)
  [in] | global_num_end | global number of past-the end block item (1 to n numbering)
  [in] | buf_block_size | Local data buffer block size, or 0 for default global_num_end - global_num_start (only useful on rank 0)
  [in] | buf | pointer to local block data buffer
  [in] | comm | associated MPI communicator

Returns
  pointer to new serializer structure.

void cs_file_serializer_destroy | ( | cs_file_serializer_t ** | s | ) |

Destroy a cs_file_serializer_t structure.

Parameters

  [in,out] | s | pointer to pointer structure that should be destroyed

void cs_file_set_big_endian | ( | cs_file_t * | f | ) |

Ensure that data is read or written in big-endian (network standard) format.

Parameters

  [in,out] | f | cs_file_t descriptor

void cs_file_set_default_access | ( | cs_file_mode_t | mode,
|  | cs_file_access_t | method,
|  | MPI_Info | hints
| ) |  |

Set the default options for file access.

If the method given contains incompatible values, such as when setting MPI-IO methods when MPI-IO is not available, a "reasonable" default is used instead.

Parameters

  [in] | mode | file mode for which the default is being set (write and append use the same method, and are interchangeable here)
  [in] | method | default access method to set
  [in] | hints | MPI-IO hints, or MPI_INFO_NULL

void cs_file_set_default_comm | ( | int | block_rank_step,
|  | int | block_min_size,
|  | MPI_Comm | comm
| ) |  |

Set default MPI communicator values for file access.

A block rank stepping value may be used, allowing the use of a reduced communicator for distributed block reads and writes. If this value is greater than 1, ranks not a multiple of this step must be guaranteed to be empty for block reads and writes with files opened using this default.

A minimum block size target may also be used, so as to limit the number of active blocks to a value proportional to the data size (limiting latency issues for small data sets, while not requiring too much local memory).

For each argument, an "out of range" value may be used to avoid modifying the previous default for that argument.

Parameters

  [in] | block_rank_step | MPI rank stepping between non-empty blocks for file block reads and writes (not set if <= 0)
  [in] | block_min_size | minimum block size target for non-empty distributed blocks (not set if < 1)
  [in] | comm | Handle to main MPI communicator (not set if MPI_COMM_SELF)

void cs_file_set_mpi_io_positionning | ( | cs_file_mpi_positionning_t | positionning | ) |

Set the positionning method for MPI-IO.

It is not always known whether a performance or robustness difference is to be expected using explicit file offsets or individual file pointers. Perusal of a sampling of ROMIO code would seem to indicate that no difference is to be expected, but this might change with MPI IO variants or file systems, so this advanced setting is made possible.

This setting is not available on a per-file basis, though this could be done in the future in the unexpected case of performance results showing this would be useful.

Parameters

  [in] | positionning | chosen positionning method for MPI-IO

void cs_file_set_swap_endian | ( | cs_file_t * | f,
|  | int | swap
| ) |  |

Set a file's byte-swapping behavior.

Parameters

  [in,out] | f | cs_file_t descriptor
  [in] | swap | 1 if bytes must be swapped, 0 otherwise

cs_file_off_t cs_file_size | ( | const char * | path | ) |

Return the size of a file.

If the file does not exit, 0 is returned.

Note also that for some special files, such as files in the Linux /proc directory, this may return 0.

Parameters

  [in] | path | file path.

Returns
  size of file.

cs_file_off_t cs_file_tell | ( | cs_file_t * | f | ) |

Return the position of the file pointer.

In parallel, we consider the file pointer to be equal to the highest value of the individual file pointers.

Parameters

  [in] | f | cs_file_t descriptor

Returns
  current position of the file pointer.

size_t cs_file_write_block | ( | cs_file_t * | f,
|  | const void * | buf,
|  | size_t | size,
|  | size_t | stride,
|  | cs_gnum_t | global_num_start,
|  | cs_gnum_t | global_num_end
| ) |  |

Write data to a file, each associated process providing a contiguous part of this data.

Each process should provide a (possibly empty) block of the data, and we should have: global_num_start at rank 0 = 1 global_num_start at rank i+1 = global_num_end at rank i. Otherwise, behavior (especially positioning for future reads) is undefined.

This function may require an internal copy of the data to ensure that the buffer contents are not modified, so if the buffer contents are temporary values, to be deleted after writing, using cs_file_write_block_buffer() instead may be used to avoid an unneeded memory allocation and copy.

Parameters

  [in] | f | cs_file_t descriptor
  [in] | buf | pointer to location containing data
  [in] | size | size of each item of data in bytes
  [in] | stride | number of (interlaced) values per block item
  [in] | global_num_start | global number of first block item (1 to n numbering)
  [in] | global_num_end | global number of past-the end block item (1 to n numbering)

Returns
  the (local) number of items (not bytes) sucessfully written; currently, errors are fatal.

size_t cs_file_write_block_buffer | ( | cs_file_t * | f,
|  | void * | buf,
|  | size_t | size,
|  | size_t | stride,
|  | cs_gnum_t | global_num_start,
|  | cs_gnum_t | global_num_end
| ) |  |

Write data to a file, each associated process providing a contiguous part of this data.

Each process should provide a (possibly empty) block of the data, and we should have: global_num_start at rank 0 = 1 global_num_start at rank i+1 = global_num_end at rank i. Otherwise, behavior (especially positioning for future reads) is undefined.

This function is intended to be used mainly data that is already a copy of original data (such as data that has been redistributed across processors just for the sake of output), or that is to be deleted after writing, so it may modify the values in its input buffer (notably to convert from little-endian to big-endian of vice-versa if necessary).

Parameters

  [in] | f | cs_file_t descriptor
  [in,out] | buf | pointer to location containing data
  [in] | size | size of each item of data in bytes
  [in] | stride | number of (interlaced) values per block item
  [in] | global_num_start | global number of first block item (1 to n numbering)
  [in] | global_num_end | global number of past-the end block item (1 to n numbering)

Returns
  the (local) number of items (not bytes) sucessfully written; currently, errors are fatal.

size_t cs_file_write_global | ( | cs_file_t * | f,
|  | const void * | buf,
|  | size_t | size,
|  | size_t | ni
| ) |  |

Write global data to a file.

Under MPI, data is only written by the associated communicator's root rank. The buffers on other ranks are ignored, though the file offset is updated (i.e. the call to this function is collective).

Parameters

  [in] | f | cs_file_t descriptor
  [in] | buf | pointer to location containing data
  [in] | size | size of each item of data in bytes
  [in] | ni | number of items to write

Returns
  the number of items (not bytes) sucessfully written; currently, errors are fatal.

## Variable Documentation

const char* cs_file_access_name[]

Initial value:
= {N_("default"),
N_("standard input and output, serial access"),
N_("standard input and output, parallel access"),
N_("non-collective MPI-IO, independent file open/close"),
N_("non-collective MPI-IO, collective file open/close"),
N_("collective MPI-IO")}

DOXYGEN_SHOULD_SKIP_THIS

const char* cs_file_mpi_positionning_name[]

Initial value:
= {N_("explicit offsets"),
N_("individual file pointers")}